package listFW.test;
import listFW.*;

import junit.framework.TestCase;

/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class Test_IList extends TestCase {
  
  private boolean printObject(Object o) {
    System.out.println("My list is: "+o.toString());
    return true;
  }

  public void test_MTList() {
    IList l = MTList.Singleton;
    printObject(l);
    assertEquals("MTList: ","()", l);
  }

  public void test_NEList() {
    IList l = new NEList("a", MTList.Singleton);
    printObject(l);
    assertEquals("NEList with just 'a': ", "(a)", l.toString());
  }

  public void test_IList() {
    IList l = MTList.Singleton;
    printObject(l);
    assertEquals("MTList: ", "()", l.toString());
    l = new NEList("a", MTList.Singleton);
    printObject(l);
    assertEquals("NEList with just 'a': ", "(a)", l.toString());
    l = new NEList("a", new NEList("b", MTList.Singleton)); 
    printObject(l);
    assertEquals("NEList with 'a' and 'b': ", "(a, b)", l.toString());
  }  
}
